;##########

;"SPECTRUM" routine for +128k
;----------------------------
L1B2B:  CALL $1B53        ; Overwrite 'P' channel data to use the ZX Printer.
        LD   SP,($5C3D)   ; ERR_SP. Purge the stack.
        POP  HL           ; Remove error handler address.
        LD   HL,$1303    ; $1303. The main execution loop within ROM 1.
        PUSH HL           ;
        LD   HL,$0013 ; $0013. Address of a $FF byte within ROM 1, used to generate error report "0 OK".
        PUSH HL           ;
        LD   HL,$0008   ; $0008. The address of the error handler within ROM 1.
        PUSH HL           ;
        LD   A,$20        ; Force 48K mode.
        LD   ($5B5C),A   ; $5B5C.
        JP   $5B00         ; $5B00. Swap to ROM 1 and return via a RST $08 / DEFB $FF. (23296)
;"SPECTRUM" routine for +2
;-------------------------
        CALL $1B72               ; 1B4A CD 72 1B
        LD SP, ($5C3D)           ; 1B4D ED 7B 3D 5C
        POP HL                   ; 1B51 E1
        LD HL, $1303             ; 1B52 21 03 13
        PUSH HL                  ; 1B55 E5
        LD HL, $0013             ; 1B56 21 13 00
        PUSH HL                  ; 1B59 E5
        LD HL, $0008             ; 1B5A 21 08 00
        PUSH HL                  ; 1B5D E5
        LD A, $20                ; 1B5E 3E 20
        LD ($5B5C), A            ; 1B60 32 5C 5B
        JP $5B00                 ; 1B63 C3 00 5B (23296)
;"SPECTRUM" routine for +2A/+3/+3e
;---------------------------------
.l1465  call    l14c4		; set "P" channel to use screen
        ld      sp,($5C3D)
        pop     hl		; discard current error return address
        ld      hl,$1303
        push    hl		; address to enter ROM 3 at, in main loop
        ld      hl,$0013	; "AF"
        push    hl
        ld      hl,$0008	; "BC"
        push    hl
        ld      a,$20
        ld      ($5B5C),a	; page 0, paging disabled
        push    af
        push    bc
        di
        res     4,(iy+$01)	; signal "48K BASIC" mode
        jp      $5b10		; enter 48K ROM (23312)


;SWAP
        PUSH AF                  ; 5B00 F5
        PUSH BC                  ; 5B01 C5
        LD BC, $7FFD             ; 5B02 01 FD 7F
        LD A, ($5B5C)            ; 5B05 3A 5C 5B
        XOR $10                  ; 5B08 EE 10
        DI                       ; 5B0A F3
        LD ($5B5C), A            ; 5B0B 32 5C 5B
        OUT (C), A               ; 5B0E ED 79
        LD BC, $1FFD             ; 5B10 01 FD 1F
        LD A, ($5B67)            ; 5B13 3A 67 5B
        XOR $04                  ; 5B16 EE 04
        LD ($5B67), A            ; 5B18 32 67 5B
        OUT (C), A               ; 5B1B ED 79
        EI                       ; 5B1D FB
        POP BC                   ; 5B1E C1
        POP AF                   ; 5B1F F6


;TOGGLER from Outlet #86
        LD A, ($5B00)            ; 9C40 3A 00 5B      ;SWAP
        CP $F5                   ; 9C43 FE F5
        RET NZ                   ; 9C45 C0
        LD SP, ($5C3D)           ; 9C46 ED 7B 3D 5C   ;ERR_SP
        POP HL                   ; 9C4A E1
        LD HL, ($5C4F)           ; 9C4B 2A 4F 5C      ;CHANS
        LD BC, $000F             ; 9C4E 01 0F 00
        ADD HL, BC               ; 9C51 09
        BIT 4, (IY+$01)          ; 9C52 FD CB 01 66
        JR Z, L_9C6C             ; 9C56 28 14
        LD DE, $15BE             ; 9C58 11 BE 15      ;128k->48k
        EX DE, HL                ; 9C5B EB            ;$15be... happens to match
        LD BC, $0005             ; 9C5C 01 05 00      ;required 'S' channel data
        LDIR                     ; 9C5F ED B0         ;copies: F4 09 C4 15 50
        LD HL, $1303             ; 9C61 21 03 13      ;overwriting 'P' with 'S'
        PUSH HL                  ; 9C64 E5
        RES 4, (IY+$01)          ; 9C65 FD CB 01 A6
L_9C69: JP $1B76                 ; 9C69 C3 76 1B      ;STMT_RET (BASIC ROM)

L_9C6C: SET 4, (IY+$01)          ; 9C6C FD CB 01 E6   ;48k->128k changes 'P' channel again
        LD DE, $5B34             ; 9C70 11 34 5B      ;23348
        LD (HL), E               ; 9C73 73
        INC HL                   ; 9C74 23
        LD (HL), D               ; 9C75 72
        INC HL                   ; 9C76 23
        LD DE, $5B2F             ; 9C77 11 2F 5B      ;23343
        LD (HL), E               ; 9C7A 73
        INC HL                   ; 9C7B 23
        LD (HL), D               ; 9C7C 72
        LD A, ($5B10)            ; 9C7D 3A 10 5B      ;23312 in SWAP/STOO
        CP $01                   ; 9C80 FE 01
        JR Z, L_9C8A             ; 9C82 28 06
        LD HL, $5B1D             ; 9C84 21 1D 5B      ;ONERR +128/+2
        PUSH HL                  ; 9C87 E5
        JR L_9C69                ; 9C88 18 DF

L_9C8A: LD HL, $5B3A             ; 9C8A 21 3A 5B      ;ONERR +2A/+3
        PUSH HL                  ; 9C8D E5
        LD HL, $1031             ; 9C8E 21 31 10      ;STMT_RET (Syntax ROM)
        PUSH HL                  ; 9C91 E5
       ;JP $5B5C                 ; 9C92 C3 5C 5B      ;BANKM?!
        jp $5b2e

;overwrite 'P' channel:
        LD HL, ($5C4F)           ; 1B53 2A 4F 5C
        LD DE, $0005             ; 1B56 11 05 00
        ADD HL, DE               ; 1B59 19
        LD DE, $000A             ; 1B5A 11 0A 00
        EX DE, HL                ; 1B5D EB
        ADD HL, DE               ; 1B5E 19
        EX DE, HL                ; 1B5F EB
        LD BC, $0004             ; 1B60 01 04 00
        LDIR                     ; 1B63 ED B0
        RES 3, (IY+$30)          ; 1B65 FD CB 30 9E
        RES 4, (IY+$01)          ; 1B69 FD CB 01 A6
        RET                      ; 1B6D C9
